#!/bin/tclsh
#
# v_prepre.tcl
#
set revision "May/10/2002"

#
# official homepage      : http://vware.hypermart.net
# author's email         : moopowah@yahoo.com
#
#
# :: Description ::
#     This script accompanies v_sim.tcl.  Its purpose is to make certain
#     that a PRE'ed dir's mtime is updated so that the incoming_mover
#     doesn't move it sooner than it should.  A case where this would
#     happen is if the dir which is pre'ed were made 1 hour in advance,
#     someone issues the pre and a few minutes later your cronjob for
#     incoming_mover kicks in.  The mtime on the dir is still 1 hour
#     and a few minutes ago, but you wanted it to be "a few minutes
#     ago".  An alternative is to se the 'touch' binary inside your pre
#     script; however, if you are not able to do this (i.e., you have a
#     compiled pre script and you don't want to bother finding the code
#     to edit), this is an alternative.
#
# :: Requirements ::
#     binary 'touch' in your PATH environment variable for glftpd chroot
#     (/glftpd/bin/ is a good place).
#
# :: Installation ::
#     Add the following to your glftpd.conf so that this script runs
#     before your SITE PRE command.  Thie statement assumes your pre
#     command is "SITE PRE" (read glftpd.docs if you don't know what a
#     cscript is yet!):
#         cscript site[:space:]pre        pre     /bin/v_prepre.tcl
#     Then copy v_prepre.tcl to /glftpd/bin/ and make sure it has chmod
#     0755.
#
# :: Known Bugs ::
#     1) Since there's no way for this pre cscript to know if the pre
#        syntax will result in a successful pre, it may 'touch' a given
#        dir incorrectly.  For example, the issues "SITE PRE foobarr
#        game" and the dir is actually called "foobar".  Well this
#        script will cause a 0-byte file "foobarr" to be created where
#        the cmd was issued.  This file can easily be deleted.  As
#        _some_ means of filtration, i added a check for how many
#        arguments are sent to the pre command, so if the user issues
#        "SITE PRE bla", no 0 byte files will be created if you had set
#        the below preArgs variable to 2 or more.  So basically it
#        checks how many arguments were sent and if it matches then the
#        'touch' will commence.
#
########################################################################


### Configuration ###
#
# How many arguments must be sent to the PRE command?
# Like "SITE PRE myDir mySection" would be 2.
set preArgs 2

########################################################################
 
 
set cmd [lindex $argv 0]
if {[llength $cmd] == [expr $preArgs + 2]} {
    exec -- touch "[pwd]/[lindex $cmd 2]"
}

# EOF. :-)
